
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Code examples &#8212; Battery SOH 2022 documentation</title>
    
  <link href="_static/css/theme.css" rel="stylesheet" />
  <link href="_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/basic.css" />
    
  <link rel="preload" as="script" href="_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="index.html">
  <img src="_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                
<div class="tocsection onthispage pt-5 pb-3">
    <i class="fas fa-list"></i> On this page
</div>

<nav id="bd-toc-nav">
    <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#enabling-and-disabling-training-of-normalisation-parameters">
   Enabling and disabling training of normalisation parameters
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#example-of-a-report-file">
   Example of a report file
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#loading-parameters-from-reports">
   Loading parameters from reports
  </a>
 </li>
</ul>

</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="code-examples">
<h1>Code examples<a class="headerlink" href="#code-examples" title="Permalink to this headline">¶</a></h1>
<div class="section" id="enabling-and-disabling-training-of-normalisation-parameters">
<span id="norm-train"></span><h2>Enabling and disabling training of normalisation parameters<a class="headerlink" href="#enabling-and-disabling-training-of-normalisation-parameters" title="Permalink to this headline">¶</a></h2>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># Previous steps are commented</span>
<span class="c1"># import LSTM_with_norm as wn</span>
<span class="c1"># Model = wn.LSTM_v1(10, 10)</span>
<span class="c1"># Model.from_model(old_model, disable_training=False) # NNs params&#39; training is not disabled</span>
<span class="c1"># # Disabling normalisation parameters&#39; training:</span>
<span class="n">Model</span><span class="o">.</span><span class="n">norm_params_in</span><span class="o">.</span><span class="n">requires_grad</span><span class="p">(</span><span class="kc">False</span><span class="p">)</span>
<span class="n">Model</span><span class="o">.</span><span class="n">norm_params_in</span><span class="o">.</span><span class="n">requires_grad</span><span class="p">(</span><span class="kc">False</span><span class="p">)</span>

<span class="c1"># # Re-enabling normalisation parameters&#39; training:</span>
<span class="n">Model</span><span class="o">.</span><span class="n">norm_params_in</span><span class="o">.</span><span class="n">requires_grad</span><span class="p">(</span><span class="kc">True</span><span class="p">)</span>
<span class="n">Model</span><span class="o">.</span><span class="n">norm_params_in</span><span class="o">.</span><span class="n">requires_grad</span><span class="p">(</span><span class="kc">True</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="section" id="example-of-a-report-file">
<span id="report-ex"></span><h2>Example of a report file<a class="headerlink" href="#example-of-a-report-file" title="Permalink to this headline">¶</a></h2>
<p>Taken from report “2021-08-04 14_17_43.523594-nasav1”.</p>
<div class="highlight-text notranslate"><div class="highlight"><pre><span></span>MODEL
  Model name: LSTM
  Variant: normal
  Version: 1
  Dataset Format: You et al. [56]
  Delta: 10
  Hidden layer dimension: 50
  Pooling_layer: bi_mean
  Dropout prob.: 0
  Number of linear layers: 1

TRAINING
  Number of Epochs: 75
  Learning rate: 1e-05
  Batch size: 1
  Epoch with smallest validation loss: 48
    (Epoch number starting at 0)
    Training loss: 0.019892172887921333
    Validation loss: 0.039088327437639236
  Last epoch&#39;s loss:
    Training loss:0.014121472835540771
    Validation loss: 0.03957139700651169
  Loss function: MSELoss()
  Optimizer: Adam (
Parameter Group 0
    amsgrad: False
    betas: (0.9, 0.999)
    eps: 1e-08
    lr: 1e-05
    weight_decay: 0
)

TRAINING DATASET
  Batch size: 1
  Dataset Name:Clean_Battery
  Size of the training set: 483
  Threshold (minimum capacity): 0.1
  Dimensionless variables: True  Minimum length: 160
  Resampling time step: 31.23419761657715
  Fixed Length: 150
  Batteries used: [&#39;B0006.txt&#39;, &#39;B0030.txt&#39;, &#39;B0038.txt&#39;, &#39;B0039.txt&#39;, &#39;B0041.txt&#39;, &#39;B0045.txt&#39;, &#39;B0055.txt&#39;]
  Normalization information: (tensor([0.4417, 0.4377, 0.4338, 0.4299, 0.4259, 0.4221, 0.4183, 0.4145, 0.4107,
        0.4069, 0.9869, 0.9876, 0.9881, 0.9886, 0.9890, 0.9894, 0.9898, 0.9901,
        0.9905, 0.9908]), tensor([0.2395, 0.2398, 0.2400, 0.2402, 0.2404, 0.2406, 0.2408, 0.2410, 0.2411,
        0.2413, 0.0267, 0.0249, 0.0238, 0.0230, 0.0223, 0.0217, 0.0212, 0.0207,
        0.0203, 0.0199]), tensor([0.6211]), tensor([0.1952]), &#39;zscore&#39;)

VALIDATION DATASET
  Batch Size: 1938
  Dataset Name:Clean_Battery
  Size of the training set: 1938
  Threshold (minimum capacity): 0.1
  Dimensionless variables: True  Minimum length: 160
  Resampling time step: 31.23419761657715
  Fixed Length: 150
  Batteries used: [&#39;B0005.txt&#39;, &#39;B0007.txt&#39;, &#39;B0018.txt&#39;, &#39;B0025.txt&#39;, &#39;B0026.txt&#39;, &#39;B0027.txt&#39;, &#39;B0028.txt&#39;, &#39;B0029.txt&#39;, &#39;B0031.txt&#39;, &#39;B0032.txt&#39;, &#39;B0033.txt&#39;, &#39;B0034.txt&#39;, &#39;B0036.txt&#39;, &#39;B0040.txt&#39;, &#39;B0042.txt&#39;, &#39;B0043.txt&#39;, &#39;B0044.txt&#39;, &#39;B0046.txt&#39;, &#39;B0047.txt&#39;, &#39;B0048.txt&#39;, &#39;B0053.txt&#39;, &#39;B0054.txt&#39;, &#39;B0056.txt&#39;]
  Normalization information: (tensor([0.4417, 0.4377, 0.4338, 0.4299, 0.4259, 0.4221, 0.4183, 0.4145, 0.4107,
        0.4069, 0.9869, 0.9876, 0.9881, 0.9886, 0.9890, 0.9894, 0.9898, 0.9901,
        0.9905, 0.9908]), tensor([0.2395, 0.2398, 0.2400, 0.2402, 0.2404, 0.2406, 0.2408, 0.2410, 0.2411,
        0.2413, 0.0267, 0.0249, 0.0238, 0.0230, 0.0223, 0.0217, 0.0212, 0.0207,
        0.0203, 0.0199]), tensor([0.6211]), tensor([0.1952]), &#39;zscore&#39;)
</pre></div>
</div>
</div>
<div class="section" id="loading-parameters-from-reports">
<span id="code-example-dict"></span><h2>Loading parameters from reports<a class="headerlink" href="#loading-parameters-from-reports" title="Permalink to this headline">¶</a></h2>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">torch</span> <span class="k">as</span> <span class="nn">th</span>
<span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>

<span class="n">new_model</span> <span class="o">=</span> <span class="n">LSTM_v1</span><span class="p">(</span><span class="mi">10</span><span class="p">,</span> <span class="mi">50</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>

<span class="c1"># Loading the model&#39;s parameters from another report:</span>
<span class="c1"># (delta and hidden dim must agree with the loaded dictionary)</span>

<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports/Example_report&#39;</span><span class="p">)</span>
<span class="n">new_model</span><span class="o">.</span><span class="n">load_state_dict</span><span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="s1">&#39;best_model_dict.txt&#39;</span><span class="p">))</span>
</pre></div>
</div>
</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>